unit frmPrintReportU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RpBase, RpSystem, RpDefine, RpRave;

type
  TForm2 = class(TForm)
    RvProject: TRvProject;
    RvSystem1: TRvSystem;
    procedure RvProjectAfterOpen(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
   reportList : TStrings;
    { Private declarations }
  public
    { Public declarations }
    procedure GenerateReport(Sender : TObject; ListName: String);
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

uses frmMain, ORfn, ORNet;

procedure TForm2.FormCreate(Sender: TObject);
begin
if reportList = nil then reportList := TStringList.create;

RvProject.Open;
RvProject.GetReportList( reportList, True);
RvProject.SelectReport(reportList[0],true);

end;
procedure TForm2.RvProjectAfterOpen(Sender: TObject);
var
  i,i2, n: integer;
  str,str2,ph : String;
  tList : TStrings;
  llist,alist,slist : TStrings;
  tmpCList : TStrings;
  tmpCList2 : TStrings;
begin
  ListTitle := ListName;
  tList := TStringlist.Create;
  lList := TStringlist.Create;
  aList := TStringlist.Create;
  sList := TStringlist.Create;

   tList.Clear;
//  if frmListSelect.UserPar.PRINT_ORIENTATION = 'P' then QuickRep1.Page.Orientation := poPortrait
//  else  QuickRep1.Page.Orientation := poLandscape;

  ProviderData.Text := piece(frmListSelect.User,'^',2);
  tCallV(tList,'CRHD ADDITIONAL USER INFO',[frmListSelect.DUZ]);
  if tList.Count > 0 then
  begin
     if piece(tList[0],'^',2)<> '' then ProviderData.Text := ProviderData.Caption + ' Pager: ' + piece(tList[0],'^',2)
  else
    if piece(tList[0],'^',1) <> '' then  ProviderData.Text := ProviderData.Caption + ' Office Ph: ' + piece(tList[0],'^',1)
  end;
   QRL_TeamData.Caption := piece(ListName,'^',2);


  QRM_Resident.Lines.Clear;
  QRM_Student.Lines.Clear;

   tList.Clear;

  if pos('^HOTEAM',ListName)>0 then
    begin
      n := 6;
      tCallV(tList,'CRHD HOT PROVIDER LIST', [ListName])
    end
  else
     if (pos('^Combination',ListName)>0) then
      begin
       tmpCList := TStringList.Create;
       tmpCList2 := TStringList.Create;
       tCallv(tmpCList, 'CRHD COMB TM LIST', []);
       QRL_TeamData.Caption :='';
       if tmpCList.Count > 0 then
         for i := 0 to tmpCList.Count -1 do
      begin
        tmpCList2.Clear;
        QRL_TeamData.Caption := QRL_TeamData.Caption + piece(tmpCList[i],'^',2) + ' - ';
        tCallV(tmpCList2,'CRHD TM PRV LIST', [tmpCList[i]]);
        if tmpCList2[0]='No list found' then tmpCList2.Clear;
        if tmpCList2.Count > 0 then
        for i2 := 0 to tmpCList2.Count -1 do
         if not findDup(piece(tmpCList2[i2],'^',2),tList) then tList.Append(tmpCList2[i2]);
      end;
     end
     else
    begin
      tCallV(tList,'CRHD TM PRV LIST', [ListName]);
      n :=5;
    end;

   if tList.Count > 0 then
     MixedCaseByPiece(tList, '^', 2);
     for i := 0 to tList.count -1 do
      begin
      str := tList[i];
      ph := '';
      if (piece(str,'^',n)<> '') and (piece(str,'^',n)<> '0')  then ph := 'Pg: ' + piece(str,'^',n)
      else
       if (piece(str,'^',n-1)<> '') and (piece(str,'^',n-1)<> '0') then ph := 'Ph: ' + piece(str,'^',n-1);

       if (ph = 'Pg: ') or (ph='Ph: ') then ph := '';

       if piece(str,'^',3) <> '' then str2 := format('%s (' + copy(piece(str,'^',3),1,1) + ')  %s', [piece(str,'^',2),ph])
        else  str2 := format( '%s %s',[piece(str,'^',2),ph]);

        if piece(str ,'^',3)='ATTN' then QRM_Resident.Lines.Add(str2);
       if piece(str ,'^',3)= 'RES' then QRM_Resident.Lines.Add(str2);
       if piece(str ,'^',3)= 'INTERN' then QRM_Resident.Lines.Add(str2);
       if piece(str ,'^',3)= 'FELLOW' then QRM_Resident.Lines.Add(str2);
       if piece(str ,'^',3)= 'MED STUDENT' then QRM_Student.Lines.Add(str2);
       if piece(str ,'^',3)= 'NURSE' then QRM_Student.Lines.Add(str2);
       if piece(str,'^',3) = '' then QRM_Student.Lines.Add(str2);
       end;


    if QRM_Resident.Lines.count > QRM_Student.Lines.count then
     QRBand2.Size.Height := QRM_Resident.Size.Height + 0.15
     else
       QRBand2.Size.Height := QRM_Student.Size.Height + 0.15;

    with frmListSelect.UserPar do
    begin
      if frmListSelect.UserPar.TEMP_FLD_1_TITLE <> '' then
        begin
         if pos('LRG',TEMP_FLD_1_SIZE)>0 then llist.Add('1');
         if pos('AVG',TEMP_FLD_1_SIZE)>0 then alist.Add('1');
         if pos('SM',TEMP_FLD_1_SIZE)>0 then slist.Add('1');
         if TEMP_FLD_1_SIZE = '' then alist.Add('1');
         inc(TitlesNum);
        end;
      if frmListSelect.UserPar.TEMP_FLD_2_TITLE <> '' then
        begin
         if pos('LRG',TEMP_FLD_2_SIZE)>0 then llist.Add('2');
         if pos('AVG',TEMP_FLD_2_SIZE)>0 then alist.Add('2');
         if pos('SM',TEMP_FLD_2_SIZE)>0 then slist.Add('2');
         if TEMP_FLD_2_SIZE = '' then alist.Add('2');
         inc(TitlesNum);
        end;
      if frmListSelect.UserPar.TEMP_FLD_3_TITLE <> '' then
       begin
         if pos('LRG',TEMP_FLD_3_SIZE)>0 then llist.Add('3');
         if pos('AVG',TEMP_FLD_3_SIZE)>0 then alist.Add('3');
         if pos('SM',TEMP_FLD_3_SIZE)>0 then slist.Add('3');
         if TEMP_FLD_3_SIZE = '' then alist.Add('3');
         inc(TitlesNum);
       end;
      if frmListSelect.UserPar.TEMP_FLD_4_TITLE <> '' then
       begin
         if pos('LRG',TEMP_FLD_4_SIZE)>0 then llist.Add('4');
         if pos('AVG',TEMP_FLD_4_SIZE)>0 then alist.Add('4');
         if pos('SM',TEMP_FLD_4_SIZE)>0 then slist.Add('4');
         if TEMP_FLD_4_SIZE = '' then alist.Add('4');
         inc(TitlesNum);
       end;
    end;



          case TitlesNum of
         1:  TempBoxSize := 350;
         2:  TempBoxSize := 175;
         3:  TempBoxSize := 117;
         4:  TempBoxSize := 80;
       end;

if (slist.count>0) and((llist.count = 0) and (alist.count = 0)) then
 begin
  alist.AddStrings(slist);
  slist.Clear;
 end;
if (llist.count>0) and((slist.count = 0) and (alist.count = 0)) then
begin
 alist.AddStrings(llist);
 llist.Clear;
end;

  if slist.count > 0 then
   for i:=0 to slist.count - 1 do
    begin
      if slist[i] = '1' then QRM6.Width := resizemybox('SM');
      if slist[i] = '2' then QRM7.Width := resizemybox('SM');
      if slist[i] = '3' then QRM8.Width := resizemybox('SM');
      if slist[i] = '4' then QRM9.Width := resizemybox('SM');
    end;

    if llist.count > 0 then
   for i:=0 to llist.count - 1 do
     begin
      if llist[i] = '1' then QRM6.Width := resizemybox('LRG');
      if llist[i] = '2' then QRM7.Width := resizemybox('LRG');
      if llist[i] = '3' then QRM8.Width := resizemybox('LRG');
      if llist[i] = '4' then QRM9.Width := resizemybox('LRG');
     end;

  if alist.count >0 then
    for i := 0 to alist.count - 1 do
      begin
      if alist[i] = '1' then QRM6.Width := resizemybox('AVG');
      if alist[i] = '2' then QRM7.Width := resizemybox('AVG');
      if alist[i] = '3' then QRM8.Width := resizemybox('AVG');
      if alist[i] = '4' then QRM9.Width := resizemybox('AVG');
      end;


  tList.Clear;

  if SomeList = nil then SomeList := TStringList.Create;
  SomeList.Clear;
end;

end;

end.





